Index: drivers/s390/block/dasd.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/s390/block/dasd.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/s390/block/dasd.c	22 Jul 2004 19:49:59 -0000	1.1
+++ drivers/s390/block/dasd.c	4 Aug 2004 01:29:28 -0000	1.2
@@ -6,6 +6,8 @@
  * Bugreports.to..: <Linux390@de.ibm.com>
  * (C) IBM Corporation, IBM Deutschland Entwicklung GmbH, 1999-2001
  *
+ * $Revision: 1.2 $
+ *
  * History of changes (starts July 2000)
  * 11/09/00 complete redesign after code review
  * 02/01/01 added dynamic registration of ioctls
@@ -33,6 +35,8 @@
  * 06/26/01 hopefully fixed PL030172SBA,PL030234SBA
  * 07/09/01 fixed PL030324MSH (wrong statistics output)
  * 07/16/01 merged in new fixes for handling low-mem situations
+ * 01/22/01 fixed PL030579KBE (wrong statistics)
+ * 08/07/03 fixed LTC BZ 3847 Erroneous message when formatting DASD
  */
 
 #include <linux/config.h>
@@ -70,7 +74,6 @@
 #include <asm/s390_ext.h>
 #include <asm/s390dyn.h>
 #include <asm/idals.h>
-#include <asm/dasd.h>
 
 #include "dasd_int.h"
 
@@ -84,8 +87,9 @@
 #include "dasd_diag.h"
 #endif				/*  CONFIG_DASD_DIAG */
 
-/* SECTION: exported variables of dasd.c */
-
+/********************************************************************************
+ * SECTION: exported variables of dasd.c 
+ ********************************************************************************/
 debug_info_t *dasd_debug_area;
 
 MODULE_AUTHOR ("Holger Smolinski <Holger.Smolinski@de.ibm.com>");
@@ -94,6 +98,9 @@
 MODULE_SUPPORTED_DEVICE ("dasd");
 MODULE_PARM (dasd, "1-" __MODULE_STRING (256) "s");
 MODULE_PARM (dasd_disciplines, "1-" __MODULE_STRING (8) "s");
+#if (LINUX_VERSION_CODE >= KERNEL_VERSION(2,4,12))
+MODULE_LICENSE ("GPL");
+#endif
 EXPORT_SYMBOL (dasd_chanq_enq_head);
 EXPORT_SYMBOL (dasd_debug_area);
 EXPORT_SYMBOL (dasd_chanq_enq);
@@ -103,6 +110,7 @@
 EXPORT_SYMBOL (dasd_start_IO);
 EXPORT_SYMBOL (dasd_term_IO);
 EXPORT_SYMBOL (dasd_schedule_bh);
+EXPORT_SYMBOL (dasd_schedule_bh_timed);
 EXPORT_SYMBOL (dasd_int_handler);
 EXPORT_SYMBOL (dasd_oper_handler);
 EXPORT_SYMBOL (dasd_alloc_request);
@@ -115,17 +123,24 @@
 EXPORT_SYMBOL (dasd_set_normalized_cda);
 EXPORT_SYMBOL (dasd_device_from_kdev);
 
-/* SECTION: Constant definitions to be used within this file */
+
+/********************************************************************************
+ * SECTION: Constant definitions to be used within this file 
+ ********************************************************************************/
 
 #define PRINTK_HEADER DASD_NAME":"
-#undef  DASD_PROFILE            /* fill profile information - used for */
+#define DASD_PROFILE            /* fill profile information - used for */
                                 /* statistics and perfomance           */
 
-#define DASD_MIN_SIZE_FOR_QUEUE 32
-#undef CONFIG_DYNAMIC_QUEUE_MIN_SIZE
-#define DASD_CHANQ_MAX_SIZE 6
-
-/* SECTION: prototypes for static functions of dasd.c */
+#ifndef CONFIG_PROC_FS          /* DASD_PROFILE doesn't make sense     */
+#undef DASD_PROFILE             /* without procfs                      */
+#endif /* not CONFIG_PROC_FS */
+
+#define DASD_CHANQ_MAX_SIZE 4
+
+/********************************************************************************
+ * SECTION: prototypes for static functions of dasd.c 
+ ********************************************************************************/
 
 static request_fn_proc do_dasd_request;
 static int dasd_set_device_level (unsigned int, dasd_discipline_t *, int);
@@ -147,7 +162,13 @@
 static struct block_device_operations dasd_device_operations;
 static inline dasd_device_t ** dasd_device_from_devno (int);
 static void dasd_process_queues (dasd_device_t * device);
-/* SECTION: static variables of dasd.c */
+static int  dasd_sleep_on_immediate (ccw_req_t *cqr);
+static int  dasd_devno_from_devindex (int devindex);
+static int  dasd_devindex_from_devno (int devno);
+
+/********************************************************************************
+ * SECTION: static variables of dasd.c 
+ ********************************************************************************/
 
 static devfs_handle_t dasd_devfs_handle;
 static wait_queue_head_t dasd_init_waitq;
@@ -155,7 +176,9 @@
 
 #ifdef CONFIG_DASD_DYNAMIC
 
-/* SECTION: managing dynamic configuration of dasd_driver */
+/********************************************************************************
+ * SECTION: managing dynamic configuration of dasd_driver 
+ ********************************************************************************/
 
 static struct list_head dasd_devreg_head = LIST_HEAD_INIT (dasd_devreg_head);
 
@@ -188,15 +211,17 @@
 
 #endif				/* CONFIG_DASD_DYNAMIC */
 
-/* SECTION: managing setup of dasd_driver */
+/********************************************************************************
+ * SECTION: managing setup of dasd_driver 
+ ********************************************************************************/
 
 /* default setting is probeonly, autodetect */
-static int dasd_probeonly = 1;	/* is true, when probeonly mode is active */
-static int dasd_autodetect = 1;	/* is true, when autodetection is active */
+static int dasd_probeonly =  0;	/* is true, when probeonly mode is active */
+static int dasd_autodetect = 0;	/* is true, when autodetection is active */
 
 static dasd_range_t dasd_range_head =
     { list:LIST_HEAD_INIT (dasd_range_head.list) };
-static spinlock_t range_lock = SPIN_LOCK_UNLOCKED;
+static spinlock_t range_lock     = SPIN_LOCK_UNLOCKED;
 
 /*
  * function: dasd_create_range
@@ -207,25 +232,7 @@
 dasd_create_range (int from, int to, int features)
 {
 	dasd_range_t *range = NULL;
-        int i;
 
-	if ( from > to ) {
-                printk (KERN_WARNING PRINTK_HEADER 
-                        "Adding device range %04x-%04x: range invalid, ignoring.\n",
-                        from,
-                        to);
-
-		return NULL;
-	}
-	for (i=from;i<=to;i++) {
-                if (dasd_device_from_devno(i)) {
-                        printk (KERN_WARNING PRINTK_HEADER 
-                                "device range %04x-%04x: device %04x is already in a range.\n",
-                                from,
-                                to,
-                                i);
-                }
-        }
 	range = (dasd_range_t *) kmalloc (sizeof (dasd_range_t), GFP_KERNEL);
 	if (range == NULL)
 		return NULL;
@@ -281,31 +288,70 @@
 /*
  * function: dasd_add_range
  * creates a dasd_range_t according to the arguments and
- * appends it to the list of ranges
+ * appends it to the list of ranges.
+ * If a device in the range is already in an other range, we split the 
+ * range and add the subranges (no duplicate devices).
  * additionally a devreg_t is created and added to the list of devregs
  */
-static inline dasd_range_t *
+static inline void
 dasd_add_range (int from, int to, int features)
 {
 	dasd_range_t *range;
+        int start, end, index, i;
 
-	range = dasd_create_range (from, to, features);
-	if (!range)
-		return NULL;
+	if (from > to) {
+                MESSAGE (KERN_DEBUG, 
+                         "Adding device range %04x-%04x: "
+                         "range invalid, ignoring.",
+                         from, to);
+		return;
+	}
 
-	dasd_append_range (range);
+        /* loop over the given range, remove the already contained devices */
+        /* and add the remaining subranges                                 */
+	for (start = index = from, end = -EINVAL; index <= to; index++) {
+                
+                if (dasd_devindex_from_devno(index) > 0) {
+                        /* current device is already in range */
+                        MESSAGE (KERN_DEBUG,
+                                 "dasd_add_range %04x-%04x: "
+                                 "device %04x is already in range",
+                                 from, to, index);
+
+                        if (start == index) 
+                                start++;        /* first already in range */
+                        else
+                                end = index -1; /* current already in range */
+                } else {
+                        if (index == to) 
+                                end = to; /* end of original range reached */
+                }
+
+                range = NULL;
+                if (end != -EINVAL) {
+                        MESSAGE (KERN_DEBUG,
+                                 "dasd_add_range %04x-%04x: "
+                                 "add (sub)range %04x-%04x",
+                                 from, to, start, end);
+                        
+                        range = dasd_create_range (start, end, features); 
+                        end = -EINVAL;
+                        start = index + 1; 
+                }
+
+                if (range) {
+                        dasd_append_range (range);
 #ifdef CONFIG_DASD_DYNAMIC
-	/* allocate and chain devreg infos for the devnos... */
-	{
-		int i;
-		for (i = range->from; i <= range->to; i++) {
-			dasd_devreg_t *reg = dasd_create_devreg (i);
-			s390_device_register (&reg->devreg);
-			list_add (&reg->list, &dasd_devreg_head);
-		}
-	}
+                        /* allocate and chain devreg infos for the devnos... */
+                        for (i = range->from; i <= range->to; i++) {
+                                dasd_devreg_t *reg = dasd_create_devreg (i);
+                                s390_device_register (&reg->devreg);
+                                list_add (&reg->list, &dasd_devreg_head);
+                        }
 #endif				/* CONFIG_DASD_DYNAMIC */
-	return range;
+                }
+        }
+	return;
 }
 
 /*
@@ -392,7 +438,9 @@
 	return -ENODEV;
 }
 
-/* SECTION: parsing the dasd= parameter of the parmline/insmod cmdline */
+/********************************************************************************
+ * SECTION: parsing the dasd= parameter of the parmline/insmod cmdline 
+ ********************************************************************************/
 
 /*
  * char *dasd[] is intended to hold the ranges supplied by the dasd= statement
@@ -426,11 +474,14 @@
 			*end = '\0';
 			end++;
 		}
-		dasd[count] = kmalloc (len * sizeof (char), GFP_ATOMIC);
+		dasd[count] = kmalloc (len * sizeof (char), 
+                                       GFP_ATOMIC);
 		if (dasd[count] == NULL) {
-			printk (KERN_WARNING PRINTK_HEADER
-				"can't store dasd= parameter no %d\n",
-				count + 1);
+
+			MESSAGE (KERN_WARNING,
+                                 "can't store dasd= parameter no"
+                                 " %d",
+                                 count + 1);
 			break;
 		}
 		memset (dasd[count], 0, len * sizeof (char));
@@ -500,10 +551,13 @@
         int val,i,start;
 
         buffer=(char*)kmalloc((strlen(str)+1)*sizeof(char),GFP_ATOMIC);
+
         if (buffer==NULL) {
-            printk (KERN_WARNING PRINTK_HEADER
-                    "can't parse dasd= parameter %s due to low memory\n",
-                    str);
+
+                MESSAGE_LOG (KERN_WARNING,
+                             "can't parse dasd= parameter %s due "
+                             "to low memory",
+                             str);
         }
 
         /* remove leading '0x' */
@@ -528,7 +582,7 @@
         val = simple_strtoul (buffer, &buffer, 16);
 
         /* check for features - e.g. (ro) ; the '\0', ')' and '-' stops check */
-        *features = DASD_DEFAULT_FEATURES;
+        *features = DASD_FEATURE_DEFAULT;
 
         if (temp[i]=='(') {
 
@@ -545,14 +599,18 @@
                                         (*features) |= DASD_FEATURE_READONLY;
                                         break;
                                 }
-                                printk (KERN_WARNING PRINTK_HEADER 
-                                        "unsupported feature: %s, ignoring setting",
-                                        buffer);
+
+                                MESSAGE_LOG (KERN_WARNING,
+                                             "unsupported feature: %s, "
+                                             "ignoring setting",
+                                             buffer);
                         }
                 }
         }
 
         *stra = temp+i;
+        if ((val > 0xFFFF) || (val < 0))
+                return -EINVAL;
         return val;
 }
 
@@ -569,22 +627,23 @@
         int features;
         int rc = 0;
 
-	if (*str) {
-		/* turn off probeonly mode, if any dasd parameter is present */
-		dasd_probeonly = 0;
-		dasd_autodetect = 0;
-	}
 	while (*str) {
 		temp = *str;
 		from = 0;
 		to = 0;
 		if (strcmp ("autodetect", *str) == 0) {
 			dasd_autodetect = 1;
-			printk (KERN_INFO "turning to autodetection mode\n");
+
+			MESSAGE (KERN_INFO, "%s",
+                                 "turning to autodetection mode");
+
 			break;
 		} else if (strcmp ("probeonly", *str) == 0) {
 			dasd_probeonly = 1;
-			printk (KERN_INFO "turning to probeonly mode\n");
+
+			MESSAGE (KERN_INFO, "%s",
+                                 "turning to probeonly mode");
+
 			break;
 		} else {
 			/* turn off autodetect mode, if any range is present */
@@ -609,20 +668,16 @@
         return rc;
 }
 
-/* SECTION: Dealing with devices registered to multiple major numbers */
+/********************************************************************************
+ * SECTION: Dealing with devices registered to multiple major numbers 
+ ********************************************************************************/
 
 static spinlock_t dasd_major_lock = SPIN_LOCK_UNLOCKED;
 
-static major_info_t dasd_major_info[] = {
-	{
-	      list:LIST_HEAD_INIT (dasd_major_info[1].list)
-	 },
-	{
-	      list:LIST_HEAD_INIT (dasd_major_info[0].list),
-	      gendisk:{
-	  INIT_GENDISK (94, DASD_NAME, DASD_PARTN_BITS, DASD_PER_MAJOR)
-	  },
-      flags:DASD_MAJOR_INFO_IS_STATIC}
+static struct list_head dasd_major_info = LIST_HEAD_INIT(dasd_major_info);
+static major_info_t dasd_major_static = {
+        gendisk:{INIT_GENDISK(94, DASD_NAME, DASD_PARTN_BITS, DASD_PER_MAJOR)},
+        flags: DASD_MAJOR_INFO_IS_STATIC
 };
 
 static major_info_t *
@@ -658,8 +713,11 @@
 	if (major_info == NULL) {
 		major_info = get_new_major_info ();
 		if (!major_info) {
-			printk (KERN_WARNING PRINTK_HEADER
-				"Cannot get memory to allocate another major number\n");
+
+			MESSAGE (KERN_WARNING, "%s",
+				"Cannot get memory to allocate another "
+                                 "major number");
+
 			return -ENOMEM;
 		}
 	}
@@ -686,10 +744,12 @@
         /* register blockdevice */
 	rc = devfs_register_blkdev (major, DASD_NAME, &dasd_device_operations);
 	if (rc < 0) {
-		printk (KERN_WARNING PRINTK_HEADER
-			"Cannot register to major no %d, rc = %d\n",
-                        major, 
-                        rc);
+                
+		MESSAGE (KERN_WARNING,
+                         "Cannot register to major no %d, rc = %d",
+                         major, 
+                         rc);
+
 		goto out_reg_blkdev; 
 	} else {
 		major_info->flags |= DASD_MAJOR_INFO_REGISTERED;
@@ -698,7 +758,7 @@
 	/* Insert the new major info into dasd_major_info if needed (dynamic major) */
 	if (!(major_info->flags & DASD_MAJOR_INFO_IS_STATIC)) {
 		spin_lock_irqsave (&dasd_major_lock, flags);
-		list_add_tail (&major_info->list, &dasd_major_info[0].list);
+		list_add_tail (&major_info->list, &dasd_major_info);
 		spin_unlock_irqrestore (&dasd_major_lock, flags);
 	}
 
@@ -791,10 +851,11 @@
         /* unregister blockdevice */
 	rc = devfs_unregister_blkdev (major, DASD_NAME);
 	if (rc < 0) {
-		printk (KERN_WARNING PRINTK_HEADER
-			"Unable to unregister from major no %d, rc = %d\n", 
-                        major,
-			rc);
+
+		MESSAGE (KERN_WARNING,
+                         "Unable to unregister from major no %d, rc = %d", 
+                         major,
+                         rc);
 	} else {
 		major_info->flags &= ~DASD_MAJOR_INFO_REGISTERED;
 	}
@@ -844,10 +905,12 @@
 
 	rc = devfs_unregister_blkdev (major, DASD_NAME);
 	if (rc < 0) {
-		printk (KERN_WARNING PRINTK_HEADER
-			"Cannot unregister from major no %d, rc = %d\n",
-                        major,
-			rc);
+
+		MESSAGE (KERN_WARNING,
+                         "Cannot unregister from major no %d, rc = %d",
+                         major,
+                         rc);
+
 		return rc;
 	} else {
 		major_info->flags &= ~DASD_MAJOR_INFO_REGISTERED;
@@ -874,20 +937,23 @@
 dasd_device_t *
 dasd_device_from_kdev (kdev_t kdev)
 {
-	major_info_t *major_info = NULL;
+	major_info_t *major_info;
+        dasd_device_t *device;
 	struct list_head *l;
 	unsigned long flags;
 
+        device = NULL;
 	spin_lock_irqsave (&dasd_major_lock, flags);
-	list_for_each (l, &dasd_major_info[0].list) {
+	list_for_each (l, &dasd_major_info) {
 		major_info = list_entry (l, major_info_t, list);
-		if (major_info->gendisk.major == MAJOR (kdev))
+		if (major_info->gendisk.major == MAJOR (kdev)) {
+                        device = major_info->dasd_device[MINOR (kdev) >>
+                                                         DASD_PARTN_BITS];
 			break;
+                }
 	}
 	spin_unlock_irqrestore (&dasd_major_lock, flags);
-	if (major_info != &dasd_major_info[0])
-		return major_info->dasd_device[MINOR (kdev) >> DASD_PARTN_BITS];
-	return NULL;
+        return device;
 }
 
 /*
@@ -900,21 +966,29 @@
 dasd_device_from_devno (int devno)
 {
 	major_info_t *major_info;
+        dasd_device_t **device;
 	struct list_head *l;
-	int devindex = dasd_devindex_from_devno (devno);
+	int devindex;
 	unsigned long flags;
 
 	spin_lock_irqsave (&dasd_major_lock, flags);
-	list_for_each (l, &dasd_major_info[0].list) {
+        devindex = dasd_devindex_from_devno (devno);
+        if (devindex < 0) {
+                spin_unlock_irqrestore (&dasd_major_lock, flags);
+                return NULL;
+        }
+
+        device = NULL;
+	list_for_each (l, &dasd_major_info) {
 		major_info = list_entry (l, major_info_t, list);
 		if (devindex < DASD_PER_MAJOR) {
-			spin_unlock_irqrestore (&dasd_major_lock, flags);
-			return &major_info->dasd_device[devindex];
+                        device = &major_info->dasd_device[devindex];
+                        break;
 		}
 		devindex -= DASD_PER_MAJOR;
 	}
 	spin_unlock_irqrestore (&dasd_major_lock, flags);
-	return NULL;
+	return device;
 }
 
 /*
@@ -945,9 +1019,33 @@
 	return -ENODEV;
 }
 
+/*
+ * function: dasd_check_bp_block
+ * checks the blocksize and returns 0 if valid.
+ */
+
+static int
+dasd_check_bp_block (dasd_device_t *device)
+{
+        int rc;
 
+        switch (device->sizes.bp_block) {
+        case 512:
+        case 1024:
+        case 2048:
+        case 4096:
+                rc = 0;
+                break;
+        default:
+                rc = -EMEDIUMTYPE;
+        }
+        
+        return rc;
+}
 
-/* SECTION: managing dasd disciplines */
+/********************************************************************************
+ * SECTION: managing dasd disciplines 
+ ********************************************************************************/
 
 /* anchor and spinlock for list of disciplines */
 static struct list_head dasd_disc_head = LIST_HEAD_INIT(dasd_disc_head);
@@ -955,14 +1053,18 @@
 
 /*
  * function dasd_discipline_enq
- * chains the discpline given as argument to the head of disiplines
- * head chaining policy is required to allow module disciplines to
- * be preferred against those, who are statically linked
+ * chains the discpline given as argument to the tail of disiplines.
+ * Exception: DIAG is always queued to the head, to ensure that CMS RESERVED
+ * minidisks are invariably accessed using DIAG.
  */
 static inline void
-dasd_discipline_enq (dasd_discipline_t * d)
+dasd_discipline_enq (dasd_discipline_t *discipline)
 {
-    list_add(&d->list, &dasd_disc_head);
+        if (strncmp (discipline->name, "DIAG", 4) == 0) {
+                list_add (&discipline->list, &dasd_disc_head);
+        } else {
+                list_add_tail (&discipline->list, &dasd_disc_head);
+        }
 }
 
 /*
@@ -970,59 +1072,88 @@
  * removes the discipline given as argument from the list of disciplines
  */
 static inline void
-dasd_discipline_deq (dasd_discipline_t * d)
+dasd_discipline_deq (dasd_discipline_t * discipline)
 {
-        list_del(&d->list);
+        if (&discipline->list) {
+                list_del (&discipline->list);
+        }
 }
 
 void
-dasd_discipline_add (dasd_discipline_t * d)
+dasd_discipline_add (dasd_discipline_t * discipline)
 {
         unsigned long flags;
         MOD_INC_USE_COUNT;
 	spin_lock_irqsave (&discipline_lock,flags);
-        dasd_discipline_enq (d);
+        dasd_discipline_enq (discipline);
 	spin_unlock_irqrestore (&discipline_lock,flags);
-        dasd_enable_ranges (&dasd_range_head, d, DASD_STATE_ONLINE);
+
+        dasd_enable_ranges (&dasd_range_head, 
+                            discipline, 
+                            DASD_STATE_ONLINE);
 }
 
-void dasd_discipline_del (dasd_discipline_t * d)
+void dasd_discipline_del (dasd_discipline_t * discipline)
 {
         unsigned long flags;
+
+        dasd_disable_ranges(&dasd_range_head,
+                            discipline, 
+                            DASD_STATE_DEL, 
+                            1);
+
 	spin_lock_irqsave (&discipline_lock,flags);
-        dasd_disable_ranges(&dasd_range_head, d, DASD_STATE_DEL, 1);
-        dasd_discipline_deq (d);
+        dasd_discipline_deq (discipline);
 	spin_unlock_irqrestore (&discipline_lock,flags);
         MOD_DEC_USE_COUNT;
 }
 
+/*
+ * function dasd_find_disc
+ * checks the list of disciplines for the first one able to access the device
+ */
 static inline dasd_discipline_t *
-dasd_find_disc (dasd_device_t * device, dasd_discipline_t *d)
+dasd_find_disc (dasd_device_t * device, dasd_discipline_t *discipline)
 {
         dasd_discipline_t *t;
-        struct list_head *l = d ? &d->list : dasd_disc_head.next;
+        struct list_head *l = discipline ? 
+                              &discipline->list : dasd_disc_head.next;
+
         do {
                 t = list_entry(l,dasd_discipline_t,list);
+
                 if ( ( t->id_check == NULL ||
                        t->id_check (&device->devinfo) == 0 ) &&
                      ( t->check_characteristics == NULL ||
                        t->check_characteristics (device) == 0 ) )
                         break;
                 l = l->next;
-                if ( d || 
+                if ( discipline || 
                      l == &dasd_disc_head ) {
                         t = NULL;
                         break;
                 }
          } while ( 1 );
+
 	return t;
 }
 
-/* SECTION: profiling stuff */
+/********************************************************************************
+ * SECTION: profiling stuff 
+ ********************************************************************************/
+
+#ifdef CONFIG_PROC_FS
 
 static dasd_profile_info_t dasd_global_profile;
+#endif  /* CONFIG_PROC_FS */
 
 #ifdef DASD_PROFILE
+
+#define DASD_PROFILE_ON  1
+#define DASD_PROFILE_OFF 0
+
+static unsigned int dasd_profile_level = DASD_PROFILE_OFF;
+
 /*
  * macro: dasd_profile_add_counter
  * increments counter in global and local profiling structures
@@ -1032,7 +1163,7 @@
 { \
         int ind; \
         long help; \
-	for (ind = 0, help = value >> 3; \
+	for (ind = 0, help = value >> 2; \
              ind < 31 && help; \
              help = help >> 1, ind++) {} \
 	dasd_global_profile.counter[ind]++; \
@@ -1086,56 +1217,134 @@
 	dasd_profile_add_counter (irqtime / sectors, dasd_io_time2ps, device);
 	dasd_profile_add_counter (endtime, dasd_io_time3, device);
 }
-#endif
+#endif /* DASD_PROFILE */
 
-/* SECTION: All the gendisk stuff */
+/********************************************************************************
+ * SECTION: All the gendisk stuff 
+ ********************************************************************************/
 
 
-/* SECTION: Managing wrappers for ccwcache */
+/********************************************************************************
+ * SECTION: Managing wrappers for ccwcache 
+ ********************************************************************************/
 
 /*
  * function dasd_alloc_request
  * tries to return space for a channel program of length cplength with
  * additional data of size datasize.
- * If the ccwcache cannot fulfill the request it tries the emergeny requests
- * before giving up finally
+ * If the ccwcache cannot fulfill the request it tries the lowmem requests
+ * before giving up finally.
  * FIXME: initialization of ccw_req_t should be done by function of ccwcache
  */
 ccw_req_t *
-dasd_alloc_request (char *magic, int cplength, int datasize, dasd_device_t* device)
+dasd_alloc_request (char *magic, int cplength, int datasize, 
+                    dasd_device_t *device)
 {
-	ccw_req_t *rv = NULL;
+	ccw_req_t *cqr;
+        unsigned long size_needed;
+	unsigned long data_offset, ccw_offset;
+        dasd_lowmem_t *lowmem;
+ 
+        if ((cqr = ccw_alloc_request (magic, cplength, datasize)) != NULL) {
+                return cqr;
+        }
+
+	/* Sanity checks */
+	if (magic == NULL || datasize > PAGE_SIZE ||
+            cplength == 0 || (cplength * sizeof(ccw1_t)) > PAGE_SIZE)
+		BUG();
 
-	if ((rv = ccw_alloc_request (magic, cplength, datasize)) != NULL) {
-		return rv;
+        /* use lowmem page only for ERP or */
+        /* if there are less than 2 requests on queue */
+        if (device->queue.head != NULL &&
+            device->queue.head->next != NULL &&
+            device->queue.head->status != CQR_STATUS_ERROR) {
+                return NULL;
+        }
+
+	/* We try to keep things together in memory */
+	size_needed = (sizeof (ccw_req_t) + 7) & (~7L);
+	data_offset = ccw_offset = 0;
+	if (size_needed + datasize <= PAGE_SIZE) {
+		/* Keep data with the request */
+		data_offset = size_needed;
+		size_needed += (datasize + 7) & (~7L);
+	}
+	if (size_needed + cplength*sizeof(ccw1_t) <= PAGE_SIZE) {
+		/* Keep CCWs with request */
+		ccw_offset = size_needed;
+		size_needed += (cplength*sizeof(ccw1_t)) & (~7L);
 	}
-	if ((((sizeof (ccw_req_t) + 7) & -8) +
-	     cplength * sizeof (ccw1_t) + datasize) > PAGE_SIZE) {
-		BUG ();
+        
+        /* take page from lowmem_pool for request */
+        list_for_each_entry (lowmem, &device->lowmem_pool, list) {
+                list_del (&lowmem->list);
+                cqr = (ccw_req_t *) lowmem;
+                memset (cqr, 0, PAGE_SIZE);
+                cqr->flags |= CQR_FLAGS_LM_CQR;
+                break;
+        }
+	if (cqr == NULL)
+		return NULL;
+
+	/* take page from lowmem_pool for the extra data */
+	if (data_offset == 0) {
+
+                list_for_each_entry (lowmem, &device->lowmem_pool, list) {
+                        list_del (&lowmem->list);
+                        cqr->data = (void *) lowmem;
+                        memset (cqr->data, 0, PAGE_SIZE);
+                        break;
+                }
+		if (cqr->data == NULL) {
+			printk(KERN_DEBUG PRINTK_HEADER 
+			       "Couldn't allocate data area\n");
+                        
+                        lowmem = (dasd_lowmem_t *) cqr;
+                        list_add (&lowmem->list, &device->lowmem_pool);
+			return NULL;
 		}
-        if (device->lowmem_cqr==NULL) {
-                DASD_DRIVER_DEBUG_EVENT (2, dasd_alloc_request,
-                                         "(%04x) Low memory! Using emergency request %p.",
-                                         device->devinfo.devno,
-                                         device->lowmem_ccws);
-
-                device->lowmem_cqr=device->lowmem_ccws;
-                rv = device->lowmem_ccws;
-		memset (rv, 0, PAGE_SIZE);
-		strncpy ((char *) (&rv->magic), magic, 4);
-		ASCEBC ((char *) (&rv->magic), 4);
-		rv->cplength = cplength;
-		rv->datasize = datasize;
-		rv->data = (void *) ((long) rv + PAGE_SIZE - datasize);
-		rv->cpaddr = (ccw1_t *) ((long) rv + sizeof (ccw_req_t));
-        } else {
-                DASD_DRIVER_DEBUG_EVENT (2, dasd_alloc_request,
-                                         "(%04x) Refusing emergency mem for request "
-                                         "NULL, already in use at %p.",
-                                         device->devinfo.devno,
-                                         device->lowmem_ccws);
-	}
-	return rv;
+	} else {
+		/* Extra data already allocated with the request */
+		cqr->data = (void *) ((addr_t) cqr + data_offset);
+        }
+
+	/* take page from lowmem_pool for the channel program */
+	if (ccw_offset == 0) {
+
+                list_for_each_entry (lowmem, &device->lowmem_pool, list) {
+                        list_del (&lowmem->list);
+                        cqr->cpaddr = (ccw1_t *) lowmem;
+                        memset (cqr->cpaddr, 0, PAGE_SIZE);
+                        break;
+                }
+
+		if (cqr->cpaddr == NULL) {
+			printk (KERN_DEBUG PRINTK_HEADER
+				"Couldn't allocate channel program area\n");
+			if (data_offset == 0) {
+                                lowmem = (dasd_lowmem_t *) cqr->data;
+                                list_add (&lowmem->list, &device->lowmem_pool);
+                        }
+                        lowmem = (dasd_lowmem_t *) cqr;
+                        list_add (&lowmem->list, &device->lowmem_pool);
+			return NULL;
+		}
+	} else {
+		/* Channel program already allocated with the request */
+		cqr->cpaddr = (ccw1_t *) ((addr_t) cqr + ccw_offset);
+        }
+
+        /* use the remaining memory of the cqr page for IDALs */
+        cqr->lowmem_idal_ptr = (void *) ((addr_t) cqr + size_needed);
+
+	strncpy ((char *)(&cqr->magic), magic, 4);
+
+	ASCEBC((char *)(&cqr->magic), 4);
+	cqr->cplength = cplength;
+	cqr->datasize = datasize;
+
+	return cqr;
 }
 
 /*
